import java.lang.*;
import java.io.*;
import java.util.*;

class CacheMonitor implements Runnable{
    public static final long SLEEP = 100;
    public static final int FWEB = 1;
    public static final int FDISK = 2;
    public static final int ERROR = -1;

    // File trace = new File("c:/temp/myTraceFile");
    //File dir = new File("c:\temp");
    File trace = new File("myTraceFile.txt");
    public CacheMonitor(){
	//File trace = new File("/afs/cs.wisc.edu/u/b/o/temp/myTraceFile");
	//	File trace = new File("myTraceFile");
	System.out.println("the trace file is:" + trace.getName());
	System.out.println("the trace file size is: " + trace.length());
	
    }
  
    public int parse(String inline){
	System.out.println("inline: " + inline);
	StringTokenizer st = new StringTokenizer(inline,",");
	if(st.countTokens() == 2)
	    return ERROR;
	else if( st.countTokens() > 5 ){
	    //System.out.println("next token: " + st.nextToken(","));
	    //if((st.nextToken(",")).startsWith("#"))
		return FDISK;
	}
	else
	    return FWEB;
	
	
    }
    
    public void run(){
	int totalCounts = 0; //total number of clicks on the web browser
	int hit = 0; // number of hits on the cache.
	int hitratio = 0;
	boolean isUpdate = false;
	Display d = new Display();

	long fileSize = 0;
	
	System.out.println("running the cachemonitor.");
	while(!Monitor.isTerminate){
	    
	    long newFileSize = trace.length();
	    System.out.println("newFileSize: " + newFileSize);
	    // System.out.println("newFileSize"+ newFileSize);
	    if(newFileSize > fileSize){ 
		fileSize = newFileSize;
		//new page brought in 
		String oneClick = new String();
		try{
		    BufferedReader in = new BufferedReader(new FileReader(trace));
		    int count = 0;
		    for(;;){
		    	
			String line = in.readLine();
			System.out.println(line);
			
			
			if( line == null )
			    break;
			
		   
			if( line.startsWith("#") && oneClick.length() != 0){
			    //parse the line, update total, hit and hitratio
			    int result = parse(oneClick);
			    
			    if( result > 0)
				totalCounts += 1;
			    if(result == FDISK)
				hit += 1;
			    System.out.println("total: " + totalCounts + "hit" + hit);
			    hitratio = (int)((double)hit/(double)totalCounts*100);
			    System.out.println("hitratio: " + hitratio);
			    d.setValue(hitratio);
			    d.update();
			
			    oneClick = line;
			    count = 0;
			}
			else{
			    if(oneClick.length() == 0)//first record
			        oneClick = line;
			    else{
				count += 1;
				if(count == 1)
				    oneClick += ","+ line;
			    }
			}
		    }
		}catch(IOException e) { e.printStackTrace();}
	    }
	    
	    //wake up every 100 milsec to check if the user checked the browser
	    try{
		Thread.sleep(SLEEP);
	    }catch(InterruptedException e){
		e.printStackTrace();
	    }
	    
	}
    }
}
