/** Analyzer the statistics of the orders 
 *  and visualize the statistics
 */

import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class Display {

    // Visualization Tool
    private HistFrame frame;
  
    //hitratio
    int hitratio;

    /** Intialize the analyzer */
    Display()
    {   
	//Visualize the queues by using histogram
	frame = new HistFrame(hitratio, 100, 10, "hitratio" );
	frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    
	frame.setLocation( 0, 0 );
	frame.setSize( new Dimension( 200, 300 ) );
	frame.setVisible( true );
    }


    /** Calculation of the following
     * update the display
     */
    public void update()
    {
	frame.update(hitratio);
	frame.setVisible( true );
    }

    public void setValue(int hit){ 
	hitratio = hit;
    }
} 
      	
	



    


